diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/wifi-phy-cca-test.cc ns-3.45/src/wifi/test/wifi-phy-cca-test.cc
--- ns-3.44/src/wifi/test/wifi-phy-cca-test.cc	2025-03-09 16:55:49.811372800 -0700
+++ ns-3.45/src/wifi/test/wifi-phy-cca-test.cc	2025-06-01 20:34:45.640702200 -0700
@@ -879,29 +1083,21 @@
 }
 
 void
-WifiPhyCcaIndicationTest::SendHeSuPpdu(dBm_u txPower, MHz_u frequency, MHz_u bandwidth)
+WifiPhyCcaIndicationTest::SendSuPpdu(dBm_u txPower, MHz_u frequency, MHz_u bandwidth)
 {
     NS_LOG_FUNCTION(this << txPower);
 
-    auto channelNum = WifiPhyOperatingChannel::FindFirst(0,
-                                                         frequency,
-                                                         bandwidth,
-                                                         WIFI_STANDARD_80211ax,
-                                                         WIFI_PHY_BAND_5GHZ)
-                          ->number;
+    auto channelNum =
+        WifiPhyOperatingChannel::FindFirst(0, frequency, bandwidth, m_standard, WIFI_PHY_BAND_6GHZ)
+            ->number;
     m_txPhy->SetOperatingChannel(
-        WifiPhy::ChannelTuple{channelNum, bandwidth, WIFI_PHY_BAND_5GHZ, 0});
-
-    WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs0(),
-                                         0,
-                                         WIFI_PREAMBLE_HE_SU,
-                                         NanoSeconds(800),
-                                         1,
-                                         1,
-                                         0,
-                                         bandwidth,
-                                         false);
+        WifiPhy::ChannelTuple{channelNum, bandwidth, WIFI_PHY_BAND_6GHZ, 0});
 
+    const auto mcs =
+        (m_standard == WIFI_STANDARD_80211ax) ? HePhy::GetHeMcs0() : EhtPhy::GetEhtMcs0();
+    const auto preamble =
+        (m_standard == WIFI_STANDARD_80211ax) ? WIFI_PREAMBLE_HE_SU : WIFI_PREAMBLE_EHT_MU;
+    WifiTxVector txVector{mcs, 0, preamble, NanoSeconds(800), 1, 1, 0, bandwidth, false};
     Ptr<Packet> pkt = Create<Packet>(1000);
     WifiMacHeader hdr;
     hdr.SetType(WIFI_MAC_QOSDATA);
@@ -982,7 +1178,7 @@
     for (const auto& generatedPpdu : generatedPpdus)
     {
         Simulator::Schedule(delay + generatedPpdu.startTime,
-                            &WifiPhyCcaIndicationTest::SendHeSuPpdu,
+                            &WifiPhyCcaIndicationTest::SendSuPpdu,
                             this,
                             generatedPpdu.power,
                             generatedPpdu.centerFreq,
@@ -1030,6 +1226,99 @@
 }
 
 void
+WifiPhyCcaIndicationTest::ResetExpectedPer20MhzCcaBusyDurations()
+{
+    m_expectedPer20MhzCcaBusyDurations.clear();
+    switch (static_cast<uint16_t>(m_channelWidth))
+    {
+    case 20:
+    default:
+        // no Per-20 MHz CCA
+        m_expectedPer20MhzCcaBusyDurations.emplace_back();
+        m_expectedPer20MhzCcaBusyDurations.emplace_back();
+        break;
+    case 40:
+        m_expectedPer20MhzCcaBusyDurations.push_back({MicroSeconds(0), MicroSeconds(0)});
+        m_expectedPer20MhzCcaBusyDurations.push_back({MicroSeconds(0), MicroSeconds(0)});
+        break;
+    case 80:
+        m_expectedPer20MhzCcaBusyDurations.push_back({
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+        });
+        m_expectedPer20MhzCcaBusyDurations.push_back({
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+        });
+        break;
+    case 160:
+        m_expectedPer20MhzCcaBusyDurations.push_back({
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+        });
+        m_expectedPer20MhzCcaBusyDurations.push_back({
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+        });
+        break;
+    case 320:
+        m_expectedPer20MhzCcaBusyDurations.push_back({
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+        });
+        m_expectedPer20MhzCcaBusyDurations.push_back({
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+            MicroSeconds(0),
+        });
+        break;
+    }
+}
+
+void
 WifiPhyCcaIndicationTest::DoSetup()
 {
     // WifiHelper::EnableLogComponents ();
@@ -1039,9 +1328,14 @@
 
     Ptr<Node> rxNode = CreateObject<Node>();
     Ptr<WifiNetDevice> rxDev = CreateObject<WifiNetDevice>();
-    rxDev->SetStandard(WIFI_STANDARD_80211ax);
-    Ptr<VhtConfiguration> vhtConfiguration = CreateObject<VhtConfiguration>();
+    rxDev->SetStandard(m_standard);
+    auto vhtConfiguration = CreateObject<VhtConfiguration>();
     rxDev->SetVhtConfiguration(vhtConfiguration);
+    if (m_standard > WIFI_STANDARD_80211ax)
+    {
+        auto ehtConfiguration = CreateObject<EhtConfiguration>();
+        rxDev->SetEhtConfiguration(ehtConfiguration);
+    }
     m_rxPhy = CreateObject<SpectrumWifiPhy>();
     m_rxPhyStateListener = std::make_unique<CcaTestPhyListener>();
     m_rxPhy->RegisterListener(m_rxPhyStateListener);
@@ -1053,7 +1347,7 @@
         CreateObject<ThresholdPreambleDetectionModel>();
     m_rxPhy->SetPreambleDetectionModel(preambleDetectionModel);
     m_rxPhy->AddChannel(spectrumChannel);
-    m_rxPhy->ConfigureStandard(WIFI_STANDARD_80211ax);
+    m_rxPhy->ConfigureStandard(m_standard);
     m_rxPhy->SetDevice(rxDev);
     rxDev->SetPhy(m_rxPhy);
     rxNode->AddDevice(rxDev);
@@ -1067,7 +1361,7 @@
     Ptr<ErrorRateModel> txErrorModel = CreateObject<NistErrorRateModel>();
     m_txPhy->SetErrorRateModel(txErrorModel);
     m_txPhy->AddChannel(spectrumChannel);
-    m_txPhy->ConfigureStandard(WIFI_STANDARD_80211ax);
+    m_txPhy->ConfigureStandard(m_standard);
     m_txPhy->SetDevice(txDev);
     txDev->SetPhy(m_txPhy);
     txNode->AddDevice(txDev);
@@ -1098,23 +1392,27 @@
     auto channelNum = WifiPhyOperatingChannel::FindFirst(0,
                                                          m_frequency,
                                                          m_channelWidth,
-                                                         WIFI_STANDARD_80211ax,
-                                                         WIFI_PHY_BAND_5GHZ)
+                                                         m_standard,
+                                                         WIFI_PHY_BAND_6GHZ)
                           ->number;
 
     m_rxPhy->SetOperatingChannel(
-        WifiPhy::ChannelTuple{channelNum, m_channelWidth, WIFI_PHY_BAND_5GHZ, 0});
+        WifiPhy::ChannelTuple{channelNum, m_channelWidth, WIFI_PHY_BAND_6GHZ, 0});
     m_txPhy->SetOperatingChannel(
-        WifiPhy::ChannelTuple{channelNum, m_channelWidth, WIFI_PHY_BAND_5GHZ, 0});
+        WifiPhy::ChannelTuple{channelNum, m_channelWidth, WIFI_PHY_BAND_6GHZ, 0});
+
+    const auto& ppduDurations =
+        (m_standard == WIFI_STANDARD_80211ax) ? hePpduDurations : ehtPpduDurations;
 
-    std::vector<Time> expectedPer20MhzCcaBusyDurations{};
     Time delay;
     Simulator::Schedule(delay, &WifiPhyCcaIndicationTest::Reset, this);
     delay += Seconds(1);
 
+    ResetExpectedPer20MhzCcaBusyDurations();
+
     //----------------------------------------------------------------------------------------------------------------------------------
-    // Verify PHY state stays IDLE and no CCA-BUSY indication is reported when a signal below the
-    // energy detection threshold occupies P20
+    // Verify PHY state stays IDLE and no CCA-BUSY indication is reported when a signal below
+    // the energy detection threshold occupies P20
     Simulator::Schedule(delay,
                         &WifiPhyCcaIndicationTest::LogScenario,
                         this,
@@ -1124,7 +1422,7 @@
         {{dBm_u{-65}, MicroSeconds(0), MicroSeconds(100), P20_CENTER_FREQUENCY, MHz_u{20}}},
         {},
         {
-            {aCcaTime, WifiPhyState::IDLE}, // IDLE after aCCATime
+            {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
             {MicroSeconds(100) - smallDelta,
              WifiPhyState::IDLE}, // IDLE just before the transmission ends
             {MicroSeconds(100) + smallDelta,
@@ -1134,18 +1432,22 @@
     delay += Seconds(1);
 
     //----------------------------------------------------------------------------------------------------------------------------------
-    // Verify PHY state is CCA-BUSY as long as a 20 MHz signal above the energy detection threshold
-    // occupies P20
+    // Verify PHY state is CCA-BUSY as long as a 20 MHz signal above the energy detection
+    // threshold occupies P20
     Simulator::Schedule(delay,
                         &WifiPhyCcaIndicationTest::LogScenario,
                         this,
                         "Reception of signal that occupies P20 above ED threshold");
+    if (m_channelWidth > 20)
+    {
+        m_expectedPer20MhzCcaBusyDurations.at(0).at(0) = MicroSeconds(100);
+    }
     ScheduleTest(
         delay,
         {{dBm_u{-60.0}, MicroSeconds(0), MicroSeconds(100), P20_CENTER_FREQUENCY, MHz_u{20}}},
         {},
         {
-            {aCcaTime, WifiPhyState::CCA_BUSY}, // CCA-BUSY after aCCATime
+            {aCcaTimeWithDelta, WifiPhyState::CCA_BUSY}, // CCA-BUSY after aCcaTimeWithDelta
             {MicroSeconds(100) - smallDelta,
              WifiPhyState::CCA_BUSY}, // CCA-BUSY just before the transmission ends
             {MicroSeconds(100) + smallDelta,
@@ -1154,192 +1456,142 @@
         {{MicroSeconds(100) - smallDelta,
           MicroSeconds(100),
           WIFI_CHANLIST_PRIMARY,
-          ((m_channelWidth > MHz_u{20})
-               ? ((m_channelWidth > MHz_u{40})
-                      ? ((m_channelWidth > MHz_u{80}) ? std::vector<Time>{MicroSeconds(100),
-                                                                          MicroSeconds(0),
-                                                                          MicroSeconds(0),
-                                                                          MicroSeconds(0),
-                                                                          MicroSeconds(0),
-                                                                          MicroSeconds(0),
-                                                                          MicroSeconds(0),
-                                                                          MicroSeconds(0)}
-                                                      : std::vector<Time>{MicroSeconds(100),
-                                                                          MicroSeconds(0),
-                                                                          MicroSeconds(0),
-                                                                          MicroSeconds(0)})
-                      : std::vector<Time>{MicroSeconds(100), MicroSeconds(0)})
-               : std::vector<Time>{})}});
+          m_expectedPer20MhzCcaBusyDurations.at(0)}});
     delay += Seconds(1);
+    ResetExpectedPer20MhzCcaBusyDurations();
 
     //----------------------------------------------------------------------------------------------------------------------------------
-    // Verify PHY state is CCA-BUSY as long as the sum of 20 MHz signals occupying P20 is above the
-    // energy detection threshold
+    // Verify PHY state is CCA-BUSY as long as the sum of 20 MHz signals occupying P20 is above
+    // the energy detection threshold
     Simulator::Schedule(delay,
                         &WifiPhyCcaIndicationTest::LogScenario,
                         this,
                         "Reception of two 20 MHz signals that occupies P20 below ED threshold with "
                         "sum above ED threshold");
-    ScheduleTest(
-        delay,
-        {{dBm_u{-64.0}, MicroSeconds(0), MicroSeconds(100), P20_CENTER_FREQUENCY, MHz_u{20}},
-         {dBm_u{-65.0}, MicroSeconds(50), MicroSeconds(200), P20_CENTER_FREQUENCY, MHz_u{20}}},
-        {},
-        {
-            {MicroSeconds(50) + aCcaTime, WifiPhyState::CCA_BUSY}, // CCA-BUSY after aCCATime
-            {MicroSeconds(100) - smallDelta,
-             WifiPhyState::CCA_BUSY}, // CCA-BUSY just before the transmission ends
-            {MicroSeconds(100) + smallDelta,
-             WifiPhyState::IDLE} // IDLE just after the transmission ends
-        },
-        {{MicroSeconds(100) - smallDelta,
-          MicroSeconds(100),
-          WIFI_CHANLIST_PRIMARY,
-          ((m_channelWidth > MHz_u{20})
-               ? ((m_channelWidth > MHz_u{40})
-                      ? ((m_channelWidth > MHz_u{80}) ? std::vector<Time>{MicroSeconds(50),
-                                                                          MicroSeconds(0),
-                                                                          MicroSeconds(0),
-                                                                          MicroSeconds(0),
-                                                                          MicroSeconds(0),
-                                                                          MicroSeconds(0),
-                                                                          MicroSeconds(0),
-                                                                          MicroSeconds(0)}
-                                                      : std::vector<Time>{MicroSeconds(50),
-                                                                          MicroSeconds(0),
-                                                                          MicroSeconds(0),
-                                                                          MicroSeconds(0)})
-                      : std::vector<Time>{MicroSeconds(50), MicroSeconds(0)})
-               : std::vector<Time>{})}});
+    if (m_channelWidth > 20)
+    {
+        m_expectedPer20MhzCcaBusyDurations.at(0).at(0) = MicroSeconds(50);
+    }
+    ScheduleTest(delay,
+                 {{-64.0, MicroSeconds(0), MicroSeconds(100), P20_CENTER_FREQUENCY, MHz_u{20}},
+                  {-65.0, MicroSeconds(50), MicroSeconds(200), P20_CENTER_FREQUENCY, MHz_u{20}}},
+                 {},
+                 {
+                     {MicroSeconds(50) + aCcaTimeWithDelta,
+                      WifiPhyState::CCA_BUSY}, // CCA-BUSY after aCcaTimeWithDelta
+                     {MicroSeconds(100) - smallDelta,
+                      WifiPhyState::CCA_BUSY}, // CCA-BUSY just before the transmission ends
+                     {MicroSeconds(100) + smallDelta,
+                      WifiPhyState::IDLE} // IDLE just after the transmission ends
+                 },
+                 {{MicroSeconds(100) - smallDelta,
+                   MicroSeconds(100),
+                   WIFI_CHANLIST_PRIMARY,
+                   m_expectedPer20MhzCcaBusyDurations.at(0)}});
     delay += Seconds(1);
+    ResetExpectedPer20MhzCcaBusyDurations();
 
     //----------------------------------------------------------------------------------------------------------------------------------
-    // Verify PHY state stays IDLE when a 20 MHz HE SU PPDU with received power below the
+    // Verify PHY state stays IDLE when a 20 MHz PPDU with received power below the
     // corresponding CCA sensitivity threshold occupies P20
     Simulator::Schedule(
         delay,
         &WifiPhyCcaIndicationTest::LogScenario,
         this,
-        "Reception of a 20 MHz HE PPDU that occupies P20 below CCA sensitivity threshold");
+        "Reception of a 20 MHz PPDU that occupies P20 below CCA sensitivity threshold");
     ScheduleTest(delay,
                  {},
                  {{dBm_u{-85}, MicroSeconds(0), P20_CENTER_FREQUENCY, MHz_u{20}}},
                  {
-                     {aCcaTime, WifiPhyState::IDLE}, // IDLE after aCCATime
-                     {PpduDurations.at(MHz_u{20}) - smallDelta,
+                     {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
+                     {ppduDurations.at(MHz_u{20}) - smallDelta,
                       WifiPhyState::IDLE}, // IDLE just before the transmission ends
-                     {PpduDurations.at(MHz_u{20}) + smallDelta,
+                     {ppduDurations.at(MHz_u{20}) + smallDelta,
                       WifiPhyState::IDLE} // IDLE just after the transmission ends
                  },
                  {});
     delay += Seconds(1);
 
     //----------------------------------------------------------------------------------------------------------------------------------
-    // Verify PHY state transitions to CCA-BUSY when an HE SU PPDU with received power above the CCA
-    // sensitivity threshold occupies P20. The per20Bitmap should indicate idle on the primary 20
-    // MHz subchannel because received power is below -72 dBm (27.3.20.6.5).
+    // Verify PHY state transitions to CCA-BUSY when an PPDU with received power above the CCA
+    // sensitivity threshold occupies P20. The per20Bitmap should indicate idle on the primary
+    // 20 MHz subchannel because received power is below -72 dBm (27.3.20.6.5).
     Simulator::Schedule(
         delay,
         &WifiPhyCcaIndicationTest::LogScenario,
         this,
-        "Reception of a 20 MHz HE PPDU that occupies P20 above CCA sensitivity threshold");
+        "Reception of a 20 MHz PPDU that occupies P20 above CCA sensitivity threshold");
     ScheduleTest(
         delay,
         {},
         {{dBm_u{-80}, MicroSeconds(0), P20_CENTER_FREQUENCY, MHz_u{20}}},
         {
-            {aCcaTime, WifiPhyState::CCA_BUSY}, // CCA-BUSY after aCCATime
-            {PpduDurations.at(MHz_u{20}) - smallDelta,
+            {aCcaTimeWithDelta, WifiPhyState::CCA_BUSY}, // CCA-BUSY after aCcaTimeWithDelta
+            {ppduDurations.at(MHz_u{20}) - smallDelta,
              WifiPhyState::RX}, // RX just before the transmission ends
-            {PpduDurations.at(MHz_u{20}) + smallDelta,
+            {ppduDurations.at(MHz_u{20}) + smallDelta,
              WifiPhyState::IDLE} // IDLE just after the transmission ends
         },
-        {{aCcaTime,
+        {{aCcaTimeWithDelta,
           MicroSeconds(16),
           WIFI_CHANLIST_PRIMARY,
-          ((m_channelWidth > 20)
-               ? ((m_channelWidth > 40)
-                      ? ((m_channelWidth > 80)
-                             ? std::vector<Time>{Seconds(0),
-                                                 Seconds(0),
-                                                 Seconds(0),
-                                                 Seconds(0),
-                                                 Seconds(0),
-                                                 Seconds(0),
-                                                 Seconds(0),
-                                                 Seconds(0)}
-                             : std::vector<Time>{Seconds(0), Seconds(0), Seconds(0), Seconds(0)})
-                      : std::vector<Time>{Seconds(0), Seconds(0)})
-               : std::vector<Time>{})}});
+          m_expectedPer20MhzCcaBusyDurations.at(0)}});
     delay += Seconds(1);
 
     //----------------------------------------------------------------------------------------------------------------------------------
-    // Verify PHY state stays IDLE when a 40 MHz HE SU PPDU with received power below the CCA
+    // Verify PHY state stays IDLE when a 40 MHz PPDU with received power below the CCA
     // sensitivity threshold occupies P40
     Simulator::Schedule(
         delay,
         &WifiPhyCcaIndicationTest::LogScenario,
         this,
-        "Reception of a 40 MHz HE PPDU that occupies P20 below CCA sensitivity threshold");
+        "Reception of a 40 MHz PPDU that occupies P20 below CCA sensitivity threshold");
     ScheduleTest(delay,
                  {},
                  {{dBm_u{-80}, MicroSeconds(0), P40_CENTER_FREQUENCY, MHz_u{40}}},
                  {
-                     {aCcaTime, WifiPhyState::IDLE}, // IDLE after aCCATime
-                     {PpduDurations.at(MHz_u{40}) - smallDelta,
+                     {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
+                     {ppduDurations.at(MHz_u{40}) - smallDelta,
                       WifiPhyState::IDLE}, // IDLE just before the transmission ends
-                     {PpduDurations.at(MHz_u{40}) + smallDelta,
+                     {ppduDurations.at(MHz_u{40}) + smallDelta,
                       WifiPhyState::IDLE} // IDLE just after the transmission ends
                  },
                  {});
     delay += Seconds(1);
 
     //----------------------------------------------------------------------------------------------------------------------------------
-    // Verify PHY state transitions to CCA-BUSY when an HE SU PPDU with received power above the CCA
-    // sensitivity threshold occupies P40. The per20Bitmap should indicate idle on the primary 20
-    // MHz subchannel because received power is below -72 dBm (27.3.20.6.5).
+    // Verify PHY state transitions to CCA-BUSY when an PPDU with received power above the CCA
+    // sensitivity threshold occupies P40. The per20Bitmap should indicate idle on the primary
+    // 20 MHz subchannel because received power is below -72 dBm (27.3.20.6.5).
     Simulator::Schedule(
         delay,
         &WifiPhyCcaIndicationTest::LogScenario,
         this,
-        "Reception of a 40 MHz HE PPDU that occupies P40 above CCA sensitivity threshold");
+        "Reception of a 40 MHz PPDU that occupies P40 above CCA sensitivity threshold");
     ScheduleTest(
         delay,
         {},
         {{dBm_u{-75}, MicroSeconds(0), P40_CENTER_FREQUENCY, MHz_u{40}}},
         {
-            {aCcaTime, WifiPhyState::CCA_BUSY}, // CCA-BUSY after aCCATime
-            {PpduDurations.at(MHz_u{40}) - smallDelta,
+            {aCcaTimeWithDelta, WifiPhyState::CCA_BUSY}, // CCA-BUSY after aCcaTimeWithDelta
+            {ppduDurations.at(MHz_u{40}) - smallDelta,
              (m_channelWidth > MHz_u{20})
                  ? WifiPhyState::RX
                  : WifiPhyState::CCA_BUSY}, // RX or IDLE just before the transmission ends
-            {PpduDurations.at(MHz_u{40}) + smallDelta,
+            {ppduDurations.at(MHz_u{40}) + smallDelta,
              WifiPhyState::IDLE} // IDLE just after the transmission ends
         },
-        {{aCcaTime,
+        {{aCcaTimeWithDelta,
           MicroSeconds(16),
           WIFI_CHANLIST_PRIMARY,
-          ((m_channelWidth > 20)
-               ? ((m_channelWidth > 40)
-                      ? ((m_channelWidth > 80)
-                             ? std::vector<Time>{Seconds(0),
-                                                 Seconds(0),
-                                                 Seconds(0),
-                                                 Seconds(0),
-                                                 Seconds(0),
-                                                 Seconds(0),
-                                                 Seconds(0),
-                                                 Seconds(0)}
-                             : std::vector<Time>{Seconds(0), Seconds(0), Seconds(0), Seconds(0)})
-                      : std::vector<Time>{Seconds(0), Seconds(0)})
-               : std::vector<Time>{})}});
+          m_expectedPer20MhzCcaBusyDurations.at(0)}});
     delay += Seconds(1);
 
     if (m_channelWidth > MHz_u{20})
     {
         //----------------------------------------------------------------------------------------------------------------------------------
-        // Verify PHY state stays IDLE and no CCA-BUSY indication is reported when a 20 MHz signal
-        // below the energy detection threshold occupies S20
+        // Verify PHY state stays IDLE and no CCA-BUSY indication is reported when a 20 MHz
+        // signal below the energy detection threshold occupies S20
         Simulator::Schedule(delay,
                             &WifiPhyCcaIndicationTest::LogScenario,
                             this,
@@ -1349,7 +1601,7 @@
             {{dBm_u{-65}, MicroSeconds(0), MicroSeconds(100), S20_CENTER_FREQUENCY, MHz_u{20}}},
             {},
             {
-                {aCcaTime, WifiPhyState::IDLE}, // IDLE after aCCATime
+                {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
                 {MicroSeconds(100) - smallDelta,
                  WifiPhyState::IDLE}, // IDLE just before the transmission ends
                 {MicroSeconds(100) + smallDelta,
@@ -1365,12 +1617,13 @@
                             &WifiPhyCcaIndicationTest::LogScenario,
                             this,
                             "Reception of a 20 MHz signal that occupies S20 above ED threshold");
+        m_expectedPer20MhzCcaBusyDurations.at(0).at(1) = MicroSeconds(100);
         ScheduleTest(
             delay,
             {{dBm_u{-60}, MicroSeconds(0), MicroSeconds(100), S20_CENTER_FREQUENCY, MHz_u{20}}},
             {},
             {
-                {aCcaTime, WifiPhyState::IDLE}, // IDLE after aCCATime
+                {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
                 {MicroSeconds(100) - smallDelta,
                  WifiPhyState::IDLE}, // IDLE just before the transmission ends
                 {MicroSeconds(100) + smallDelta,
@@ -1379,21 +1632,9 @@
             {{MicroSeconds(100) - smallDelta,
               MicroSeconds(100),
               WIFI_CHANLIST_SECONDARY,
-              ((m_channelWidth > MHz_u{40})
-                   ? ((m_channelWidth > MHz_u{80}) ? std::vector<Time>{MicroSeconds(0),
-                                                                       MicroSeconds(100),
-                                                                       MicroSeconds(0),
-                                                                       MicroSeconds(0),
-                                                                       MicroSeconds(0),
-                                                                       MicroSeconds(0),
-                                                                       MicroSeconds(0),
-                                                                       MicroSeconds(0)}
-                                                   : std::vector<Time>{MicroSeconds(0),
-                                                                       MicroSeconds(100),
-                                                                       MicroSeconds(0),
-                                                                       MicroSeconds(0)})
-                   : std::vector<Time>{MicroSeconds(0), MicroSeconds(100)})}});
+              m_expectedPer20MhzCcaBusyDurations.at(0)}});
         delay += Seconds(1);
+        ResetExpectedPer20MhzCcaBusyDurations();
 
         //----------------------------------------------------------------------------------------------------------------------------------
         // Verify PHY state is CCA-BUSY as long as a 40 MHz signal above the energy detection
@@ -1402,12 +1643,13 @@
                             &WifiPhyCcaIndicationTest::LogScenario,
                             this,
                             "Reception of a 40 MHz signal that occupies P40 above ED threshold");
+        std::fill_n(m_expectedPer20MhzCcaBusyDurations.at(0).begin(), 2, MicroSeconds(100));
         ScheduleTest(
             delay,
             {{dBm_u{-55}, MicroSeconds(0), MicroSeconds(100), P40_CENTER_FREQUENCY, MHz_u{40}}},
             {},
             {
-                {aCcaTime, WifiPhyState::CCA_BUSY}, // CCA-BUSY after aCCATime
+                {aCcaTimeWithDelta, WifiPhyState::CCA_BUSY}, // CCA-BUSY after aCcaTimeWithDelta
                 {MicroSeconds(100) - smallDelta,
                  WifiPhyState::CCA_BUSY}, // CCA-BUSY just before the transmission ends
                 {MicroSeconds(100) + smallDelta,
@@ -1416,20 +1658,9 @@
             {{MicroSeconds(100) - smallDelta,
               MicroSeconds(100),
               WIFI_CHANLIST_PRIMARY,
-              ((m_channelWidth > 40) ? ((m_channelWidth > 80) ? std::vector<Time>{MicroSeconds(100),
-                                                                                  MicroSeconds(100),
-                                                                                  MicroSeconds(0),
-                                                                                  MicroSeconds(0),
-                                                                                  MicroSeconds(0),
-                                                                                  MicroSeconds(0),
-                                                                                  MicroSeconds(0),
-                                                                                  MicroSeconds(0)}
-                                                              : std::vector<Time>{MicroSeconds(100),
-                                                                                  MicroSeconds(100),
-                                                                                  MicroSeconds(0),
-                                                                                  MicroSeconds(0)})
-                                     : std::vector<Time>{MicroSeconds(100), MicroSeconds(100)})}});
+              m_expectedPer20MhzCcaBusyDurations.at(0)}});
         delay += Seconds(1);
+        ResetExpectedPer20MhzCcaBusyDurations();
 
         //----------------------------------------------------------------------------------------------------------------------------------
         // Verify PHY notifies CCA-BUSY for the primary channel while the secondary channel was
